//Cria objeto de script
var script_docente = document.createElement('script');
var script_veiculo = document.createElement('script');
var script_qualis = document.createElement('script');
var script_regra = document.createElement('script');
var script_pontuacao = document.createElement('script');

//Recebe o diretorio do script (atributo src)
script_docente.src = 'js/Docente.js';
script_veiculo.src = 'js/Veiculo.js';
script_qualis.src = 'js/Qualis.js';
script_regra.src = 'js/Regra.js';
script_regra.src = 'js/Pontuacao.js';

//Adiciona a tag script no head da página
document.head.appendChild(script_docente);
document.head.appendChild(script_veiculo);
document.head.appendChild(script_qualis);
document.head.appendChild(script_regra);
document.head.appendChild(script_pontuacao);

//Leitura de docentes
function lerDocente(evt, vetorDocente) {
    //Verifica se o arquivo é compatível com o browser
    if (!browserSupportFileUpload()) {
        alert('The File APIs are not fully supported in this browser!');
    } else {
        var data = null;
        var file = evt.target.files[0]; //variavel file recebe o arquivo
        var reader = new FileReader(); //Cria um novo objeto FileReader
        reader.readAsText(file); //Le o arquivo como texto
        reader.onload = function(event) {
            var csvData = event.target.result;

            data = $.csv.toArrays(csvData); //transforma os dados em array

            if (data && data.length > 0) {
                console.log('Imported -' + data.length + '- rows successfully!');

                $.each(data, function(linha, value) {
                    //Ignora a 1a linha
                    if (linha > 0) {

                        //Leitura dos dados
                        var data_string = value.toString();
                        var data_string = data_string.replace(" ;", ";");
                        var data_array = data_string.split(";");
                        var codigo = data_array[0];
                        var nome = data_array[1];
                        var nascimento = data_array[2];
                        var ingresso = data_array[3];
                        var coordenador = data_array[4];
                        // cria um novo docente
                        var novoDocente = new Docente(codigo, nome, retornaData(nascimento), retornaData(ingresso), coordenador);
                        //Adiciona o docente no vetor
                        vetorDocente.push(novoDocente);
                    }
                });

            } else {
                console.log('No data to import!');
            }
        };
        reader.onerror = function() {
            console.log('Unable to read ' + file.fileName);
        };
    }
}

function lerVeiculo(evt,vetorVeiculo){
     if (!browserSupportFileUpload()) {
        alert('The File APIs are not fully supported in this browser!');
        } else {
            var data = null;
            var file = evt.target.files[0];
            var reader = new FileReader();
            reader.readAsText(file);
            reader.onload = function(event) {
                var csvData = event.target.result;
                data = $.csv.toArrays(csvData);

                if (data && data.length > 0) {
                  console.log('Imported -' + data.length + '- rows successfully!');

                 $.each( data , function( linha, value ) {
                  //Ignora a 1a linha
                  if(linha>0){

                  var data_string = value.toString();
                  var data_string = data_string.replace(" ;", ";");
                  data_array = data_string.split(";");

                  var sigla = data_array[0];
                  var nome = data_array[1];
                  var tipo = data_array[2];
                  var fator = parseFloat(data_array[3].replace(',','.'));
                  var issn = data_array[4];

                  var novo = new Veiculo(sigla,nome,tipo,fator,issn);
                  vetorVeiculo.push(novo);
                  }

                 });

                } else {
                    console.log('No data to import!');
                }
            };
            reader.onerror = function() {
                console.log('Unable to read ' + file.fileName);
            };
        }
}

function lerPublicacao(evt,vetorPublicacoes,vetorDocente,vetorVeiculo){
     if (!browserSupportFileUpload()) {
        alert('The File APIs are not fully supported in this browser!');
        } else {
            var data = null;
            var file = evt.target.files[0];
            var reader = new FileReader();
            reader.readAsText(file);
            reader.onload = function(event) {
                var csvData = event.target.result;
                data = $.csv.toArrays(csvData);

                if (data && data.length > 0) {
                  console.log('Imported -' + data.length + '- rows successfully!');

                 $.each( data , function( linha, value ) {
                  //Ignora a 1a linha
                  if(linha>0){
                  var data_string = value.toString();

                  var data_string = data_string.replace(" ;", ";");

                  data_array = data_string.split(";");

                  var ano = data_array[0];
                  var veiculo = data_array[1];
                  var titulo = data_array[2];
                  var lista_autores = data_array[3];
                  var numero = data_array[4];
                  var volume = data_array[5];
                  var local = data_array[6];
                  var inicial = data_array[7];
                  var final = data_array[8];

                  lista_autores = lista_autores.split(',');
                  let Autores = [];
                  //Encontra o docende pelo código
                  $.each(vetorDocente,function(index,oDocente){

                    for(i=0; i<lista_autores.length ; i++){
                      if(oDocente.codigo == lista_autores[i]){
                        Autores.push(oDocente);
                      }
                    }

                  });

                  //Encontra veículo
                  $.each(vetorVeiculo,function(index,oVeiculo){


                      if(oVeiculo.sigla == veiculo){
                        veiculo = oVeiculo;
                      }


                  });

                  var novo = new Publicacao(ano,veiculo,titulo,Autores,numero,volume,local,inicial,final);
                  //Insere publicaçao no docente
                  $.each(Autores,function(index,oDocente){
                    oDocente.inserePublicacao(novo);
                  });

                  vetorPublicacoes.push(novo);
                  }

                 });
                } else {
                    console.log('No data to import!');
                }
            };
            reader.onerror = function() {
                console.log('Unable to read ' + file.fileName);
            };
        }
}

function lerQualificacoes(evt,vetorVeiculo,vetorQualificacoes,tabelaQualis){
     if (!browserSupportFileUpload()) {
        alert('The File APIs are not fully supported in this browser!');
        } else {
            var data = null;
            var file = evt.target.files[0];
            var reader = new FileReader();
            reader.readAsText(file);

            reader.onload = function(event) {
                var csvData = event.target.result;

                data = $.csv.toArrays(csvData);

                if (data && data.length > 0) {
                  console.log('Imported -' + data.length + '- rows successfully!');

                 $.each( data , function( linha, value ) {
                  //Ignora a 1a linha
                  if(linha>0){

                  var data_string = value.toString();
                  
        var data_string = data_string.replace(" ;", ";");
                  data_array = data_string.split(";");

                  var ano = data_array[0];
                  var nome_veiculo = data_array[1];
                  var nome_qualis = data_array[2];

                  
                  $.each( tabelaQualis , function( index, qualis ) {
                    if(qualis.nome == nome_qualis){
                      nome_qualis = qualis;
                    }
                  });

                  var novo = new Qualificacao(ano,nome_veiculo,nome_qualis);
                  vetorQualificacoes.push(novo);

                   $.each( vetorVeiculo , function( index, veiculo ) {

                    if(veiculo.sigla == nome_veiculo){
                      veiculo.addQualificacao(novo);
                    }
                  });
                  }

                 });

                } else {
                    console.log('No data to import!');
                }
            };
            reader.onerror = function() {
                console.log('Unable to read ' + file.fileName);
            };
        }
}
function criaTabelaQualis(tabelaQualis){
  tabelaQualis.push(new Qualis('A1'));
  tabelaQualis.push(new Qualis('A2'));
  tabelaQualis.push(new Qualis('B1'));
  tabelaQualis.push(new Qualis('B2'));
  tabelaQualis.push(new Qualis('B3'));
  tabelaQualis.push(new Qualis('B4'));
  tabelaQualis.push(new Qualis('B5'));
  tabelaQualis.push(new Qualis('C'));
}
function lerRegras(evt,vetorRegras){
     if (!browserSupportFileUpload()) {
        alert('The File APIs are not fully supported in this browser!');
        } else {
            var data = null;
            var file = evt.target.files[0];
            var reader = new FileReader();
            reader.readAsText(file);
            reader.onload = function(event) {
                var csvData = event.target.result;
                data = $.csv.toArrays(csvData);
                

                if (data && data.length > 0) {
                  console.log('Imported -' + data.length + '- rows successfully!');

                 $.each( data , function( linha, value ) {
                  //Ignora a 1a linha
                  if(linha>0){
                var data_string = value.toString();

                  var data_string = data_string.replace(" ;", ";");
                  data_array = data_string.split(";");

                  var inicio = retornaData(data_array[0]);
                  var fim = retornaData(data_array[1]);

                  var qualis = data_array[2];
                  var pontos = data_array[3];

                  var multiplicador = parseFloat(data_array[4]);
                  var anos = parseInt(data_array[5]);
                  var pontuacaoMinima = parseInt(data_array[6]);

                  }

                 });

                } else {
                    console.log('No data to import!');
                }
            };
            reader.onerror = function() {
                console.log('Unable to read ' + file.fileName);
            };
        }
}

function retornaData(date){
   var date = date.split("/");
  return new Date(date[2],date[1]-1,date[0]);//substrai 1 do mes pq começa janeiro é 0
}
function browserSupportFileUpload() {
  var isCompatible = false;
  if (window.File && window.FileReader && window.FileList && window.Blob) {
    isCompatible = true;
  }
  return isCompatible;
  }
