//Relatório de publicações
function geraRelatorio2(vetorPublicacoes,saida) {

    var array_relatorio = [];

    //Percorre as publicações
    $.each(vetorPublicacoes, function(index, Publicacao) {

        var relatorio = {
            ano: '',
            sigla: '',
            veiculo: '',
            qualis: '',
            fator: '',
            titulo: '',
            autores: ''
        };
        relatorio.ano = Publicacao.ano;
        relatorio.sigla = Publicacao.veiculo.sigla;
        relatorio.veiculo = Publicacao.veiculo.nome;
        relatorio.qualis = Publicacao.veiculo.qualificacao.qualis.nome;
        relatorio.fator = Publicacao.veiculo.fator;
        relatorio.titulo = Publicacao.titulo;

        var nome_autor = '';
        //Pega o nome dos autores
        $.each(Publicacao.autores, function(index, Autor) {

            if (index == Publicacao.autores.length - 1)
                nome_autor += Autor.nome;
            else
                nome_autor += Autor.nome + ',';

        });

        relatorio.autores = nome_autor;
        //Adiciona no array de relatorio
        array_relatorio.push(relatorio);

    });
    //Ordena
    array_relatorio.sort(ordenacao_relatorio2());
    //Insere dados na tabela
    insereTabela1(array_relatorio);
    //gera formato do arquivo de saida
    saida1(array_relatorio);


}
//cria string de saida
function saida1(Relatorio) {
var imprime;
    $.each(Relatorio, function(index, relatorio) {

        var fator = parseFloat(relatorio.fator.toFixed(2));

        if ((fator % 1 != 0 && !isNaN(fator % 1))) {
            fator = fator.toString();
            fator = fator.replace(".", ",");
        } else
            fator = fator + ',000';

        imprime = relatorio.ano + ';' + relatorio.sigla + ';' + relatorio.veiculo + ';' + relatorio.qualis + ';' + fator + ';' + relatorio.titulo + ';';
        imprime += relatorio.autores  + ';\n';

        
    });
    console.log(imprime);
}

//Insere o relatório 2 na tabela
function insereTabela1(Relatorio) {

    $.each(Relatorio, function(index, relatorio) {

        var fator = parseFloat(relatorio.fator.toFixed(2));

        if ((fator % 1 != 0 && !isNaN(fator % 1))) {
            fator = fator.toString();
            fator = fator.replace(".", ",");
        } else
            fator = fator + ',000';

        var imprime = '<tr>' + '<td>' + relatorio.ano + '</td>' + '<td>' + relatorio.sigla + '</td>' + '<td>' + relatorio.veiculo + '</td>' + '<td>' + relatorio.qualis + '</td>' + '<td>' + fator + '</td>' + '<td>' + relatorio.titulo + '</td>';
        imprime += '<td>' + relatorio.autores + '</td>' + '</tr>';
        $('#collapseOne table').append(imprime);

    });
}
//Insere o relatório 3 na tabela
function insereTabela2(Relatorio) {

    $.each(Relatorio, function(index, relatorio) {

        var media = parseFloat(relatorio.qtdDocentes.toFixed(2)); //converse para float

        if ((media % 1 != 0 && !isNaN(media % 1))) {
            media = media.toString();
            media = media.replace(".", ",");
        } else
            media = media + ',000';

        var imprime = '<tr>' + '<td>' + relatorio.nome + '</td>' + '<td>' + relatorio.qtdArtigos + '</td>' + '<td>' + media + '</td>' + '</tr>';
        $('#collapseTwo table').append(imprime);

    });
}
//Gera o relatório de estatísticas
function geraRelatorio3(vetorPublicacoes, tabelaQualis) {

    var array_relatorio = [];
    var array_filtrado = [];

    var relatorio2 = {
        qualis: '',
        qtd_autores: 0,
        numero: 0,
    };
    $.each(vetorPublicacoes, function(index, Publicacao) {

        var relatorio = {
            qualis: '',
            qtd_autores: 0,
            numero: 0,
        };

        relatorio.qualis = Publicacao.veiculo.qualificacao.qualis.nome;
        relatorio.qtd_autores = Publicacao.autores.length;

        array_relatorio.push(relatorio);
    });

    var i = 0;
    $.each(array_relatorio, function(index, Relatorio) {

        $.each(tabelaQualis, function(index, Qualis) {
            if (Relatorio.qualis == Qualis.nome) {
                Qualis.incrementaArtigo();


                Qualis.incrementaAutor(parseFloat(1 / parseFloat(Relatorio.qtd_autores.toFixed(2)))); // divide artigo por quantidade de pesquisador


            }

        });
    });
    //Insere na tabela
    insereTabela2(tabelaQualis);

}
//ordena seguindo prioridade
function ordenacao_relatorio2() {
    return function(a, b) {

        if (a.qualis < b.qualis) {
            return -1;
        } else if (a.qualis > b.qualis) {
            return 1;
        } else {

            if (a.ano > b.ano) {
                return -1;
            } else if (a.ano < b.ano) {
                return 1;
            } else {
                if (a.sigla < b.sigla) {
                    return -1;
                } else if (a.sigla > b.sigla) {
                    return 1;
                } else {

                    if (a.titulo < b.titulo) {
                        return -1;
                    } else if (a.titulo > b.titulo) {
                        return 1;
                    } else {
                        return 0;
                    }
                }
            }
        }
    }
}

